﻿using System.Runtime.InteropServices;

namespace Core.Model.Types
{
    [StructLayout(LayoutKind.Sequential)]
    public struct Vector2F
    {
        public static int SizeInBytes
        {
            get { return sizeof (float)*2; }
        }

        public readonly float X;
        public readonly float Y;

        public Vector2F(float x, float y)
        {
            X = x;
            Y = y;
        }
    }
}
