﻿using SlimDX.DXGI;
using SlimDX.Direct3D10;

namespace SlimDX.Game.Model
{
    public class BlockVertex
    {
        public static InputElement[] InputElements
        {
            get
            {
                return new[]
                           {
                               new InputElement("POSITION", 0,
                                                Format.
                                                    R32_SInt,
                                                0, 0),
                               new InputElement("TEXCOORD", 0,
                                                Format.
                                                    R32G32_Float,
                                                sizeof(int), 0)
                           };
            }
        }

        public static readonly int BlockVertexSize = sizeof(int) + Vector2.SizeInBytes;
    }
}
