﻿using System.Runtime.InteropServices;
using Core.Model.Types;

namespace Core.Model
{
    [StructLayout(LayoutKind.Sequential)]
    public struct SkyDomeVertex
    {
        public static int SizeInBytes
        {
            get { return Vector3F.SizeInBytes; }// +Vector2F.SizeInBytes; }
        }

        public SkyDomeVertex(Vector3F position)
        {
            Position = position;
            //Normal = (position).Normalize();
            // TextureCoordinate = texCoord;
        }

        public readonly Vector3F Position;
        //public readonly Vector3F Normal;
        //public readonly Vector2F TextureCoordinate;
    }
}
