﻿using System;
using Core.Controllers;
using Core.Model.Chunks;

namespace Core.View.Renders
{
    public abstract class WorldRenderer
    {
        #region Properties

        public abstract IntPtr WindowHandle { get; }

        public abstract int WindowWidth { get; }
        public abstract int WindowHeight { get; }

        #endregion

        #region Public methods

        public abstract void BeginDraw();

        public abstract void DrawTerrain(Camera camera, Chunk[] chunks);

        public abstract void EndDraw();

        #endregion
    }
}
